## mccode 3.5.19+ds5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

if ( "x${MCVERSION}" STREQUAL "x" )
    set(MCVERSION 3.99.999)
    message(WARNING "Build version was unset. Define using e.g. -DMCVERSION=${MCVERSION}")
endif()

# This file will build McStas and/or McXtrace
project(mccode LANGUAGES C VERSION "${MCVERSION}")
set(CMAKE_C_STANDARD 99)
# Stash the project version for use in C macro comparisons
math(EXPR MCCODE_VERSION_MACRO "(${CMAKE_PROJECT_VERSION_MAJOR} * 100 + ${CMAKE_PROJECT_VERSION_MINOR}) * 1000 + ${CMAKE_PROJECT_VERSION_PATCH}" OUTPUT_FORMAT DECIMAL)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

#Ensure various variables are set to sensible default values for the target
#platform (if not already set by a toolchain file):

option( BUILD_MCSTAS "Build McStas" OFF )
option( BUILD_MCXTRACE "Build McXtrace" OFF )
option( BUILD_TOOLS "Include tools" ON )
option( BUILD_MCXRUN "Include mcrun/mxrun even if BUILD_TOOLS is OFF" )#fixme: replace with more fine-grained control
option( ENABLE_COMPONENTS "Whether or not to include comps and instruments" ON )
option( EXCLUDE_CONTRIB "Whether or not to exclude contrib comps" OFF )#fixme: replace with more fine-grained control
option( EXCLUDE_DATA "Whether or not to exclude data files" OFF )#fixme: replace with more fine-grained control

if ( BUILD_MCSTAS AND BUILD_MCXTRACE )
    message(WARNING "Configuration requests building both McStas and McXtrace which is likely to fail.")
elseif( NOT BUILD_MCSTAS AND NOT BUILD_MCXTRACE )
    message(FATAL_ERROR "Configuration requires building one of McStas or McXtrace via -DBUILD_MCXTRACE=ON or -DBUILD_MCSTAS=ON")
endif()

# Setup McCode values (from mkdist or defaults)
include(MCUtil)

if ( BUILD_MCSTAS )
  option( ENSURE_NCRYSTAL "Build Third Party code NCrystal if not already available" ON )
  if ( ENSURE_NCRYSTAL )
    set ( NCRYSTAL_LEGACY_USE 1 )
  else()
    set ( NCRYSTAL_LEGACY_USE 0 )
  endif()
endif()


if( BUILD_MCSTAS )
    setupMCCODE("mcstas")
    message(STATUS "Configuring McStas build ${FLAVOR}")
    add_subdirectory(mcstas)
    if ( ENABLE_COMPONENTS )
      add_subdirectory(mcstas-comps)
    endif()
    add_subdirectory(docpkg/manuals/mcstas)
endif()

if ( BUILD_MCXTRACE )
    setupMCCODE("mcxtrace")
    message(STATUS "Configuring McXtrace build ${FLAVOR}")
    add_subdirectory(mcxtrace)
    if ( ENABLE_COMPONENTS )
      add_subdirectory(mcxtrace-comps)
    endif()
    add_subdirectory(docpkg/manuals/mcxtrace)
endif()

if ( BUILD_TOOLS )
  add_subdirectory( tools )
elseif ( BUILD_MCXRUN )
  add_subdirectory( tools/Python/mcrun )
  add_subdirectory( tools/Python/mccodelib)
endif()

# Find/Fetch dependencies:

option( ENSURE_MCPL "Build Third Party code MCPL if not already available" ON )
if( ENSURE_MCPL )
  include( MCPL )
endif()

if( BUILD_MCSTAS )
  if ( ENSURE_NCRYSTAL )
    include( NCrystal )
  endif()
endif()

=== mcstas-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
project( mcstas-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcstas")

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  set(DEBIDEPS "${FLAVOR}, libnexus-dev, libgsl-dev")
else()
  set(DEBIDEPS "${FLAVOR}, libnexus-dev, libgsl-dev, cif2hkl")
endif()

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")


set(CPACK_DEBIAN_PACKAGE_DEPENDS "${DEBIDEPS}")
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-comps-3.5.1")


# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()

option( ENABLE_NEUTRONICS "Build Third Party code neutronics (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_NEUTRONICS )
  enable_language( Fortran )
  add_library(neutronics "STATIC" libs/neutronics/neutronics-subs.f)
  install(TARGETS neutronics DESTINATION "${DEST_LIBDIR}/neutronics")
  #NB (Aug 2023): Removed general "libs" which has the side-effect of not
  #installing other files related to "neutronics".
endif()

# System c-code
install( DIRECTORY "share/" DESTINATION "${DEST_DATADIR_CODEFILES}")

# Editor syntax-highlighting etc
if (NOT WINDOWS)
  file(GLOB EDITORS editors/*) # follow links (install DIRECTORY does not)
  install( FILES ${EDITORS} DESTINATION "${DEST_DATADIR_EDITORS}" )
endif()

# System comps
install( DIRECTORY "misc/"      DESTINATION "${DEST_DATADIR_COMPS}/misc")
install( DIRECTORY "monitors/"  DESTINATION "${DEST_DATADIR_COMPS}/monitors")
install( DIRECTORY "obsolete/"  DESTINATION "${DEST_DATADIR_COMPS}/obsolete")
install( DIRECTORY "optics/"    DESTINATION "${DEST_DATADIR_COMPS}/optics")
install( DIRECTORY "samples/"   DESTINATION "${DEST_DATADIR_COMPS}/samples")
install( DIRECTORY "sources/"   DESTINATION "${DEST_DATADIR_COMPS}/sources")
install( DIRECTORY "union/"     DESTINATION "${DEST_DATADIR_COMPS}/union")
install( DIRECTORY "sasmodels/" DESTINATION "${DEST_DATADIR_COMPS}/sasmodels")

# Contrib comps
if ( NOT EXCLUDE_CONTRIB )
  install( DIRECTORY "contrib/" DESTINATION "${DEST_DATADIR_COMPS}/contrib")
endif()

# Data files
if ( NOT EXCLUDE_DATA )
  install( DIRECTORY "data/"    DESTINATION "${DEST_DATADIR_COMPS}/data")
endif()

install( DIRECTORY "examples/"  DESTINATION "${DEST_DATADIR_EXAMPLES}")


# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE.md" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== mcxtrace-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McXtrace components
project( mcxtrace-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcxtrace")

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")


# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()

# Debian
if ( ENABLE_CIF2HKL )
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}, libnexus-dev, libxrl-dev, libgsl-dev")
else()
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}, libnexus-dev, libxrl-dev, libgsl-dev, cif2hkl")
endif()
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-comps-3.5.1")

# System c-code
install( DIRECTORY "share/" DESTINATION "${DEST_DATADIR_CODEFILES}")

# Editor syntax-highlighting etc
if (NOT WINDOWS)
  file(GLOB EDITORS editors/*) # follow links (install DIRECTORY does not)
  install( FILES ${EDITORS} DESTINATION "${DEST_DATADIR_EDITORS}" )
endif()

# System comps
install( DIRECTORY "misc/"      DESTINATION "${DEST_DATADIR_COMPS}/misc")
install( DIRECTORY "monitors/"  DESTINATION "${DEST_DATADIR_COMPS}/monitors")
install( DIRECTORY "obsolete/"  DESTINATION "${DEST_DATADIR_COMPS}/obsolete")
install( DIRECTORY "optics/"    DESTINATION "${DEST_DATADIR_COMPS}/optics")
install( DIRECTORY "samples/"   DESTINATION "${DEST_DATADIR_COMPS}/samples")
install( DIRECTORY "sources/"   DESTINATION "${DEST_DATADIR_COMPS}/sources")
install( DIRECTORY "union/"     DESTINATION "${DEST_DATADIR_COMPS}/union")
install( DIRECTORY "sasmodels/" DESTINATION "${DEST_DATADIR_COMPS}/sasmodels")
install( DIRECTORY "astrox/"    DESTINATION "${DEST_DATADIR_COMPS}/astrox")

# Contrib comps
if ( NOT EXCLUDE_CONTRIB )
  install( DIRECTORY "contrib/" DESTINATION "${DEST_DATADIR_COMPS}/contrib")
endif()

# Data files
if ( NOT EXCLUDE_DATA )
  install( DIRECTORY "data/"    DESTINATION "${DEST_DATADIR_COMPS}/data")
endif()

install( DIRECTORY "examples/"  DESTINATION "${DEST_DATADIR_EXAMPLES}")


# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== 3rdparty/mcpl-package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

# This will install MCPL components
project(MCPL_wrapper)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

if(WINDOWS)
  setupMCCODE("${FLAVOR}")
endif()

set(CPACK_PACKAGE_NAME "${FLAVOR}-mcpl-${MCCODE_VERSION}")
set(CPACK_PACKAGE_CONTACT       "mcpl-developers@cern.ch")
set(CPACK_PACKAGE_VERSION       "1.5.1")
set(CPACK_PACKAGE_VERSION_MAJOR "1.5")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_NSIS_PACKAGE_NAME "MCPL 1.5.1")
set(CPACK_NSIS_DISPLAY_NAME "MCPL 1.5.1")

set(CPACK_FREEBSD_PACKAGE_LICENSE "Apache-2.0")

# NSIS
set(NSIS_NAME "${CPACK_PACKAGE_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Drop any mccode-deb/rpm postfixing
set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "")
set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE "")
set(CPACK_RPM_POST_UNINSTALL_SCRIPT_FILE "")

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

if(WINDOWS)
  # batch snippets for the Python tools
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/batches/mcpl-config.bat.in" "${WORK}/mcpl-config.bat" @ONLY)
  install(
    PROGRAMS "${WORK}/mcpl-config.bat"
    DESTINATION "${bin}"
    )

  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/batches/pymcpltool.bat.in" "${WORK}/pymcpltool.bat" @ONLY)
  install(
    PROGRAMS "${WORK}/pymcpltool.bat"
    DESTINATION "${bin}"
    )
endif()

add_subdirectory(mcpl)

=== 3rdparty/ncrystal-package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

# This will install NCrystal components
project(NCrystal_wrapper)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")
set(NCRYSTAL_ENABLE_EXAMPLES OFF)

# To be built with/for McStas
set(BUILD_MCSTAS   "Choose the McStas flavor" on)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
# Set McCode values (from mkdist or defaults)
include(MCUtil)

set(FLAVOR "mcstas")

if(WINDOWS)
  setupMCCODE("${FLAVOR}")
endif()

set(CPACK_PACKAGE_NAME "${FLAVOR}-NCrystal-${MCCODE_VERSION}")
set(CPACK_PACKAGE_CONTACT       "ncrystal-developers@cern.ch")
set(CPACK_PACKAGE_VERSION       "3.4.1")
set(CPACK_PACKAGE_VERSION_MAJOR "3.4")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_NSIS_PACKAGE_NAME "NCrystal 3.4.1")
set(CPACK_NSIS_DISPLAY_NAME "NCrystal 3.4.1")

set(CPACK_FREEBSD_PACKAGE_LICENSE "Apache-2.0")

# NSIS
set(NSIS_NAME "${CPACK_PACKAGE_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Drop any mccode-deb/rpm postfixing
set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "")
set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE "")
set(CPACK_RPM_POST_UNINSTALL_SCRIPT_FILE "")

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

if(WINDOWS)
  # batch snippets for the Python tools
  foreach (tool ncrystal-config ncrystal_endf2ncmat ncrystal_hfg2ncmat ncrystal_inspectfile ncrystal_ncmat2cpp ncrystal_ncmat2hkl ncrystal_preparemcstasdir ncrystal_vdos2ncmat ncrystal_verifyatompos)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/batches/${tool}.bat.in" "${WORK}/${tool}.bat" @ONLY)
    install(
      PROGRAMS "${WORK}/${tool}.bat"
      DESTINATION "${bin}"
      )
  endforeach()
endif()

add_subdirectory(ncrystal)

=== 3rdparty/nexus-package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

# This will install NeXus components
project(NeXus_wrapper)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()
setupMCCODE("${FLAVOR}")

set(CPACK_PACKAGE_NAME "${FLAVOR}-nexus-${MCCODE_VERSION}")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")
set(CPACK_PACKAGE_VERSION       "0.0.1")
set(CPACK_PACKAGE_VERSION_MAJOR "0.0")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_NSIS_PACKAGE_NAME "NeXus 0.0.1")
set(CPACK_NSIS_DISPLAY_NAME "NeXus 0.0.1")

# NSIS
set(NSIS_NAME "${CPACK_PACKAGE_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

add_subdirectory(nexus-code)

=== tools/Python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)


add_subdirectory(mccodelib)
add_subdirectory(mcdisplay)
add_subdirectory(mcdoc)
add_subdirectory(mcgui)
add_subdirectory(mcplot)
add_subdirectory(mcresplot)
add_subdirectory(mcrun)
add_subdirectory(mctest)

=== tools/cluster-scripts/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas or McXtrace mc/mxrun
project(perl-cluster-tools C)

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

message("Enabling ${FLAVOR} flavor")
setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-clustertools")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")

# NSIS
set(NSIS_NAME "Cluster scripting tools (slurm, pbs), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}, perl, libfile-which-perl")
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-clustertools-3.5.1")

# RPM
set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, perl"
  )


include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure scripts
configure_file("${CMAKE_SOURCE_DIR}/mcsub_pbs.in" "${WORK}/${FLAVOR}_mcsub_pbs" @ONLY)
configure_file("${CMAKE_SOURCE_DIR}/mcsub_slurm.in" "${WORK}/${FLAVOR}_mcsub_slurm" @ONLY)

if(WINDOWS)
  foreach(NAME "mcsub_pbs" "mcsub_slurm")
    install(
      FILES "${WORK}/${NAME}"
      DESTINATION "${bin}/${NAME}.pl"
      )
  endforeach()
else()
  foreach(NAME "${FLAVOR}_mcsub_pbs" "${FLAVOR}_mcsub_slurm")
    install(
      FILES "${WORK}/${NAME}"
      DESTINATION "${DEST_BINDIR}"
      )
  endforeach()
endif()

=== tools/matlab/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)


add_subdirectory(mcdisplay)
add_subdirectory(mcplot)

=== doc/manuals/mcstas/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
set(FLAVOR mcstas)
project(${FLAVOR}_manuals C)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

message( "CMAKE_SOURCE_DIR=        ${CMAKE_SOURCE_DIR}" )
message( "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" )
message( "CMAKE_CURRENT_LIST_DIR=  ${CMAKE_CURRENT_LIST_DIR}" )
message( "PROJECT_SOURCE_DIR=      ${PROJECT_SOURCE_DIR}" )
message( "PROJECT_BINARY_DIR=      ${PROJECT_BINARY_DIR}" )

message( "include MCUtil" )
include(MCUtil)
message( "include UseLATEX" )
include(UseLATEX)
# set(PDFLATEX_COMPILER "/usr/bin/xelatex")
message( "setup MCCODE" )
setupMCCODE("${FLAVOR}")
# CPack configuration
message( "CPack configuration" )
set(CPACK_PACKAGE_NAME          "${FLAVOR}-manuals")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")

# NSIS
set(NSIS_NAME "Manuals, ${MCCODE_VERSION}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")

set(MANUAL "${FLAVOR}-manual.pdf")
set(CMANUAL "${FLAVOR}-components.pdf")

if(WINDOWS)
  set(MCCODE_LIB "${CMAKE_INSTALL_PREFIX}/")
  set(MANDEST "${lib}/doc/manuals")
else()
  set(MCCODE_LIB "${CMAKE_INSTALL_PREFIX}/${MCCODE_NAME}")
  set(MANDEST "${FLAVOR}/${MCCODE_VERSION}/doc/manuals")
endif()


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}")
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-manuals-3.5.1")

include(CPack)

message( "LaTeX configuration" )
# set(LATEX_OUTPUT_PATH ".")
file(GLOB LIST RELATIVE "${CMAKE_CURRENT_LIST_DIR}" "*.tex" "*.sty" "*.bib" "*.bst" "[m-s]*/*.tex" "[m-s]*/*.parms" "figures/*")

foreach(NAME sources samples optics monitors misc)
  add_custom_command(
    OUTPUT "${NAME}.done"
    COMMAND "${PROJECT_SOURCE_DIR}/get_mcdoc_snippets.sh" "${NAME}" "${PROJECT_SOURCE_DIR}"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    )
endforeach()

set(LATEX_OUTPUT_PATH "${PROJECT_BINARY_DIR}")
add_latex_document(
  manual.tex 
  INPUTS ${LIST}
  DEPENDS sources.done samples.done optics.done monitors.done misc.done
  BIBFILES "mcstas.bib"
  USE_INDEX
  FORCE_PDF
  )
add_latex_document(
  Component_manual.tex 
  INPUTS ${LIST}
  DEPENDS sources.done samples.done optics.done monitors.done misc.done
  BIBFILES "mcstas.bib"
  USE_INDEX
  FORCE_PDF
  )

install(FILES "${PROJECT_BINARY_DIR}/manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${MANUAL}"
)

install(FILES "${PROJECT_BINARY_DIR}/Component_manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${CMANUAL}"
)

=== doc/manuals/mcxtrace/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McXtrace user and component manuals.
set(FLAVOR mcxtrace)
project(${FLAVOR}_manuals C)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

message( "CMAKE_SOURCE_DIR=        ${CMAKE_SOURCE_DIR}" )
message( "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" )
message( "CMAKE_CURRENT_LIST_DIR=  ${CMAKE_CURRENT_LIST_DIR}" )
message( "PROJECT_SOURCE_DIR=      ${PROJECT_SOURCE_DIR}" )
message( "PROJECT_BINARY_DIR=      ${PROJECT_BINARY_DIR}" )

message( "include MCUtil" )
include(MCUtil)
message( "include UseLATEX" )
include(UseLATEX)
#set(PDFLATEX_COMPILER "/usr/bin/xelatex")
message( "setup MCCODE" )
setupMCCODE("${FLAVOR}")

# CPack configuration
message( "CPack configuration" )
set(CPACK_PACKAGE_NAME          "${FLAVOR}-manuals")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "erkn@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")

# NSIS
set(NSIS_NAME "Manuals, ${MCCODE_VERSION}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")

set(MANUAL "${FLAVOR}-manual.pdf")
set(CMANUAL "${FLAVOR}-components.pdf")

if(WINDOWS)
  set(MCCODE_LIB "${CMAKE_INSTALL_PREFIX}/")
  set(MANDEST "${lib}/doc/manuals")
else()
  set(MCCODE_LIB "${CMAKE_INSTALL_PREFIX}/${MCCODE_NAME}")
  set(MANDEST "${FLAVOR}/${MCCODE_VERSION}/doc/manuals")
endif()


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}")
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-manuals-3.5.1")
include(CPack)

message( "LaTeX configuration" )
# set(LATEX_OUTPUT_PATH ".")
file(GLOB LIST RELATIVE "${CMAKE_CURRENT_LIST_DIR}" "*.tex" "*.sty" "*.bib" "*.bst" "[m-s]*/*.tex" "[m-s]*/*.parms" "figures/*" "Semi_mirror.comp")

foreach(NAME sources samples optics monitors misc)
  add_custom_command(
    OUTPUT "${NAME}.done"
    COMMAND "${PROJECT_SOURCE_DIR}/get_mxdoc_snippets.sh" "${NAME}" "${PROJECT_SOURCE_DIR}"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
    )
endforeach()

set(LATEX_OUTPUT_PATH "${PROJECT_BINARY_DIR}")
add_latex_document(
  manual.tex 
  INPUTS ${LIST}
  DEPENDS sources.done samples.done optics.done monitors.done misc.done
  BIBFILES "mcxtrace.bib"
  USE_INDEX
  FORCE_PDF
  )
add_latex_document(
  Component_manual.tex 
  INPUTS ${LIST}
  DEPENDS sources.done samples.done optics.done monitors.done misc.done
  BIBFILES "mcxtrace.bib"
  USE_INDEX
  FORCE_PDF
  )

install(FILES "${PROJECT_BINARY_DIR}/manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${MANUAL}"
)

install(FILES "${PROJECT_BINARY_DIR}/Component_manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${CMANUAL}"
)

=== docpkg/manuals/mcstas/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas manuals
set(FLAVOR mcstas)
project(${FLAVOR} C)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

message( "CMAKE_SOURCE_DIR=        ${CMAKE_SOURCE_DIR}" )
message( "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" )
message( "CMAKE_CURRENT_LIST_DIR=  ${CMAKE_CURRENT_LIST_DIR}" )
message( "PROJECT_SOURCE_DIR=      ${PROJECT_SOURCE_DIR}" )
message( "PROJECT_BINARY_DIR=      ${PROJECT_BINARY_DIR}" )

message( "include MCUtil" )
include(MCUtil)
message( "setup MCCODE" )
setupMCCODE("${FLAVOR}")

# CPack configuration
message( "CPack configuration" )
set(CPACK_PACKAGE_NAME          "${FLAVOR}-manuals")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_MAJOR}.${MCCODE_MINOR}.${MCCODE_PATCH}")
set(CPACK_PACKAGE_VERSION_MAJOR "${MCCODE_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MCCODE_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MCCODE_PATCH}")

# NSIS
set(NSIS_NAME "Manuals, ${MCCODE_VERSION}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")

set(MANUAL "${FLAVOR}-manual.pdf")
set(CMANUAL "${FLAVOR}-components.pdf")

set(MCCODE_LIB "${DEST_DATADIR_COMPS}")
set(MANDEST "${DEST_DATADIR_DOC}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}")
set(CPACK_DEBIAN_PACKAGE_REPLACES "${FLAVOR}-manuals-3.5.1")

include(CPack)

install(FILES "${PROJECT_SOURCE_DIR}/manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${MANUAL}"
)

install(FILES "${PROJECT_SOURCE_DIR}/Component_manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${CMANUAL}"
)

=== debian/control ===
Source: mccode
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Roland Mas <lolando@debian.org>,
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-cmake,
 dh-python,
 flex,
 gfortran,
 pandoc,
 python3-all,
 recode,
Standards-Version: 4.6.2
Homepage: https://github.com/McStasMcXtrace/McCode
Vcs-Browser: https://salsa.debian.org/science-team/mccode
Vcs-Git: https://salsa.debian.org/science-team/mccode.git
Rules-Requires-Root: no

# mcstas base packages ---------------------------------------------------------

Package: mcstas
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Neutron ray-trace simulation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas engine itself.

Package: mcstas-comps
Architecture: any
Depends:
 cif2hkl,
 libgsl-dev,
 libmcpl-dev,
 mcpl,
 mcstas,
 ${misc:Depends},
Description: Neutron ray-trace simulation - components
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas components (i.e. models for
 simulated instruments and objects).

Package: mcstas-mccodelib
Architecture: any
Depends:
 gedit,
 mcstas,
 mcstas-comps,
 python3,
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - Python code library
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains Python libraries.

Package: mcstas-mcdoc
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - documentation browser
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcdoc, a tool to display documentation for
 McStas itself and for the simulated instruments.

Package: mcstas-manuals
Architecture: any
Depends:
 mcstas-mcdoc,
 ${misc:Depends},
Description: Neutron ray-trace simulation - documentation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the documentation.

Package: mcstas-mcrun
Architecture: any
Depends:
 gcc,
 mcstas-manuals,
 mcstas-mccodelib,
 python3,
 python3-numpy,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - runner
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcrun, the command-line tool to run the
 McStat simulations.

Package: mcstas-mcgui
Architecture: any
Depends:
 mcstas-mcrun,
 python3,
 python3-pyqt5,
 python3-pyqt5.qsci,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - GUI
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the graphical user interface.

Package: mcstas-clusterscripts
Architecture: any
Depends:
 mcstas-mcrun,
 ${misc:Depends},
 ${perl:Depends},
Description: Neutron ray-trace simulation - parallelization scripts
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains scripts to run McStas in parallel on various
 types of clusters.

# mcstas plot tools ------------------------------------------------------------

Package: mcstas-mcplot-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-numpy,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matplotlib
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-numpy,
 python3-matplotlib,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matplotlib plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the Matplotlib plotting frontend for the
 simulation results.

Package: mcstas-mcplot-html
Architecture: any
Depends:
 libjs-d3,
 mcstas-mccodelib,
 python3,
 python3-numpy,
 ${misc:Depends},
Provides: mcstas-mcplot-svg
Conflicts: mcstas-mcplot-svg
Replaces: mcstas-mcplot-svg
Description: Neutron ray-trace simulation - HTML plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the HTML plotting frontend for the
 simulation results.

Package: mcstas-mcplot-matlab
Architecture: any
Depends:
 mcstas-mccodelib,
 octave,
 ${misc:Depends},
Description: Neutron ray-trace simulation - Matlab/Octave plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains a Matlab/Octave frontend for the simulation
 result viewer.

# mcstas display tools ---------------------------------------------------------

Package: mcstas-mcdisplay-pyqtgraph
Architecture: any
Depends:
 mcstas-mccodelib,
 python3,
 python3-numpy,
 python3-pyqtgraph,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - pyqtgraph instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph frontend for the instrument
 display.

Package: mcstas-mcdisplay-webgl
Architecture: any
Depends:
 libjs-three,
 mcstas-mccodelib,
 python3,
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
Description: Neutron ray-trace simulation - WebGL instrument display

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# INSTALL_PREFIX=/usr/share
INSTALL_PREFIX=/usr/
MCCODE_VERSION=3
MCVERSION=3
MCSTAS_VERSION=3.5
MCXTRACE_VERSION=3.5

# WARNING: the MCCODE_USE_LEGACY_DESTINATIONS=OFF changes the legacy tools/library destination to 'resources'
CMAKE_ARGS=-DMCCODE_VERSION=$(MCCODE_VERSION) -DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX) \
  -DMCCODE_USE_LEGACY_DESTINATIONS=OFF -DENABLE_CIF2HKL=OFF
CMAKE_ARGS_N=-Denable_mcstas=1   -DBUILD_MCSTAS=1   $(CMAKE_ARGS) -DMCVERSION=$(MCSTAS_VERSION)
CMAKE_ARGS_X=-Denable_mcxtrace=1 -DBUILD_MCXTRACE=1 $(CMAKE_ARGS) -DMCVERSION=$(MCXTRACE_VERSION)

PARALLEL=$(shell echo $DEB_BUILD_OPTIONS|xargs -n 1|grep ^parallel=|cut -d= -f2)
ifneq ($(strip $(PARALLEL)),)
	MAKE_ARGS=-j$(PARALLEL)
endif

# compile function: mccode_compile_N $pkg $src_cmake_dir
define mccode_compile_N
	# compile $(2)
	mkdir -p BUILD/$(1) && cd BUILD/$(1) && cmake $(CMAKE_ARGS_N) $(CURDIR)/$(2) && make $(MAKE_ARGS)
endef

# compile function: mccode_compile_X $pkg $src_cmake_dir
define mccode_compile_X
	# compile $(2)
	mkdir -p BUILD/$(1) && cd BUILD/$(1) && cmake $(CMAKE_ARGS_X) $(CURDIR)/$(2) && make $(MAKE_ARGS)
endef

# install function: mccode_install $pkg
define mccode_install
	# installing $(1)
	cd BUILD/$(1) && make install DESTDIR=$(CURDIR)/debian/$(1)
	# install: make executables for $(1)
	if [ -d $(CURDIR)/debian/$(1)/usr/bin ]; then \
	  chmod +x $(CURDIR)/debian/$(1)/usr/bin/*; fi
	# create man pages for $(1) if any
	for i in $$(ls $(CURDIR)/debian/$(1)/usr/share/doc/mcstas/*.md \
	  $(CURDIR)/debian/$(1)/usr/share/doc/mcxtrace/*.md); do \
	    mkdir -p $(CURDIR)/debian/$(1)/usr/share/man/man1/; \
	    bn=$$(basename -s .md $$i); \
	    pandoc --standalone --to man $$i -o $(CURDIR)/debian/$(1)/usr/share/man/man1/$${bn}.1; \
	done
endef

%:
	dh $@ --with cmake

execute_after_dh_auto_clean:
	rm -f cmake/Modules/debian.cmake

override_dh_auto_configure:

override_dh_auto_build:
	mkdir -p BUILD
	cp cmake/toolchains/deb64.cmake cmake/Modules/debian.cmake
	sed -i -e /amd64/d -e/CMAKE_SYSTEM_NAME/d cmake/Modules/debian.cmake

	# Performing mcstas build
	$(call mccode_compile_N,mcstas,mcstas)

	$(call mccode_compile_N,mcstas-comps,mcstas-comps)
	$(call mccode_compile_N,mcstas-mccodelib,tools/Python/mccodelib/)
	$(call mccode_compile_N,mcstas-mcdoc,tools/Python/mcdoc)
	$(call mccode_compile_N,mcstas-manuals,docpkg/manuals/mcstas)
	$(call mccode_compile_N,mcstas-mcrun,tools/Python/mcrun)
	$(call mccode_compile_N,mcstas-mcgui,tools/Python/mcgui)
	$(call mccode_compile_N,mcstas-clusterscripts,tools/cluster-scripts)

	$(call mccode_compile_N,mcstas-mcplot-pyqtgraph,tools/Python/mcplot/pyqtgraph)
	$(call mccode_compile_N,mcstas-mcplot-matplotlib,tools/Python/mcplot/matplotlib)
	$(call mccode_compile_N,mcstas-mcplot-html,tools/Python/mcplot/html)
	$(call mccode_compile_N,mcstas-mcplot-matlab,tools/matlab/mcplot)

	$(call mccode_compile_N,mcstas-mcdisplay-webgl,tools/Python/mcdisplay/webgl)
	$(call mccode_compile_N,mcstas-mcdisplay-webgl-classic,tools/Python/mcdisplay/webgl-classic)
	$(call mccode_compile_N,mcstas-mcdisplay-pyqtgraph,tools/Python/mcdisplay/pyqtgraph)
	$(call mccode_compile_N,mcstas-mcdisplay-matplotlib,tools/Python/mcdisplay/matplotlib/)
	$(call mccode_compile_N,mcstas-mcdisplay-matlab,tools/matlab/mcdisplay)

	$(call mccode_compile_N,mcstas-mcdisplay-mantid,tools/Python/mcdisplay/mantid_xml)
	$(call mccode_compile_N,mcstas-mcresplot,tools/Python/mcresplot)

	# Performing mcxtrace build
	$(call mccode_compile_X,mcxtrace,mcxtrace)

	$(call mccode_compile_X,mcxtrace-comps,mcxtrace-comps)
	$(call mccode_compile_X,mcxtrace-mccodelib,tools/Python/mccodelib)
	$(call mccode_compile_X,mcxtrace-mxrun,tools/Python/mcrun)
	$(call mccode_compile_X,mcxtrace-mxgui,tools/Python/mcgui)
	$(call mccode_compile_X,mcxtrace-clusterscripts,tools/cluster-scripts)
	$(call mccode_compile_X,mcxtrace-mxdoc,tools/Python/mcdoc)
	$(call mccode_compile_X,mcxtrace-manuals,docpkg/manuals/mcxtrace)

	$(call mccode_compile_X,mcxtrace-mxplot-pyqtgraph,tools/Python/mcplot/pyqtgraph)
	$(call mccode_compile_X,mcxtrace-mxplot-matplotlib,tools/Python/mcplot/matplotlib)
	$(call mccode_compile_X,mcxtrace-mxplot-html,tools/Python/mcplot/html)
	$(call mccode_compile_X,mcxtrace-mxplot-matlab,tools/matlab/mcplot)

	$(call mccode_compile_X,mcxtrace-mxdisplay-webgl,tools/Python/mcdisplay/webgl)
	$(call mccode_compile_X,mcxtrace-mxdisplay-webgl-classic,tools/Python/mcdisplay/webgl-classic)
	$(call mccode_compile_X,mcxtrace-mxdisplay-pyqtgraph,tools/Python/mcdisplay/pyqtgraph)
	$(call mccode_compile_X,mcxtrace-mxdisplay-matplotlib,tools/Python/mcdisplay/matplotlib/)
	$(call mccode_compile_X,mcxtrace-mxdisplay-matlab,tools/matlab/mcdisplay)


execute_before_dh_auto_install:
	# Performing mcstas install in packages
	$(call mccode_install,mcstas)

	$(call mccode_install,mcstas-comps)
	$(call mccode_install,mcstas-mccodelib)
	$(call mccode_install,mcstas-mcdoc)
	$(call mccode_install,mcstas-manuals)
	$(call mccode_install,mcstas-mcrun)
	$(call mccode_install,mcstas-mcgui)
	$(call mccode_install,mcstas-clusterscripts)
	$(call mccode_install,mcstas-mcplot-pyqtgraph)
	$(call mccode_install,mcstas-mcplot-matplotlib)
	$(call mccode_install,mcstas-mcplot-matlab)
	$(call mccode_install,mcstas-mcplot-html)
	$(call mccode_install,mcstas-mcdisplay-webgl)
	$(call mccode_install,mcstas-mcdisplay-webgl-classic)
	$(call mccode_install,mcstas-mcdisplay-pyqtgraph)
	$(call mccode_install,mcstas-mcdisplay-matplotlib)
	$(call mccode_install,mcstas-mcdisplay-mantid)
	$(call mccode_install,mcstas-mcdisplay-matlab)
	$(call mccode_install,mcstas-mcresplot)
	# Ignored: (mcstas-ncrystal)

	# Performing mcxtrace install in packages
	$(call mccode_install,mcxtrace)

	$(call mccode_install,mcxtrace-comps)
	$(call mccode_install,mcxtrace-mccodelib)
	$(call mccode_install,mcxtrace-clusterscripts)
	$(call mccode_install,mcxtrace-manuals)
	$(call mccode_install,mcxtrace-mxdoc)
	$(call mccode_install,mcxtrace-mxrun)
	$(call mccode_install,mcxtrace-mxgui)
	$(call mccode_install,mcxtrace-mxplot-matplotlib)
	$(call mccode_install,mcxtrace-mxplot-pyqtgraph)
	$(call mccode_install,mcxtrace-mxplot-html)
	$(call mccode_install,mcxtrace-mxplot-matlab)
	$(call mccode_install,mcxtrace-mxdisplay-webgl)
	$(call mccode_install,mcxtrace-mxdisplay-webgl-classic)
	$(call mccode_install,mcxtrace-mxdisplay-pyqtgraph)
	$(call mccode_install,mcxtrace-mxdisplay-matplotlib)
	$(call mccode_install,mcxtrace-mxdisplay-matlab)

	# Replace symlinks with the files they point to
	for i in $$(awk '/^Package:/ { print $$2 }' debian/control) ; do\
	  find debian/$$i -type l -print0 | xargs -r  -0 sed -i -e '' ; \
	done

execute_after_dh_auto_install:
	# avoid conflicts and lintian warnings
	mv debian/mcstas/usr/share/mcstas/mcstas-environment        debian/mcstas/usr/bin/
	mv debian/mcxtrace/usr/share/mcxtrace/mcxtrace-environment  debian/mcxtrace/usr/bin/
	chmod +x debian/mcxtrace-comps/usr/share/mcxtrace/resources/data/get_xray_db_data

	# module files
	mkdir -p debian/mcxtrace/etc/modulefiles
	mkdir -p debian/mcstas/etc/modulefiles
	mv debian/mcxtrace/usr/share/mcxtrace/mcxtrace-module debian/mcxtrace/etc/modulefiles/
	mv debian/mcstas/usr/share/mcstas/mcstas-module       debian/mcstas/etc/modulefiles/
	chmod -x debian/mcxtrace/etc/modulefiles/* debian/mcstas/etc/modulefiles/*

	# reproducible build
	find debian -name mccode_config.json -print0 | xargs -0rt sed -i -e "s@$(CURDIR)@/builddir@g"

	# add editor highlight syntaxing
	mkdir -p debian/mcstas-comps/usr/share/gtksourceview-4/language-specs/
	mkdir -p debian/mcxtrace-comps/usr/share/gtksourceview-4/language-specs/
	ln -s /usr/share/mcstas/editors/mccode.lang   debian/mcstas-comps/usr/share/gtksourceview-4/language-specs/mcstas.lang
	ln -s /usr/share/mcxtrace/editors/mccode.lang debian/mcxtrace-comps/usr/share/gtksourceview-4/language-specs/mcxtrace.lang

	# Remove JavaScript files as will use those from system

=== debian/tests/control ===
Tests: mcstas
Depends:
 mcstas,
 mcstas-comps,
 mcstas-mcgui,
 mcstas-mcrun,
 python3-all,
Restrictions: allow-stderr

Tests: mcxtrace
Depends:
 mcxtrace,
 mcxtrace-comps,
 mcxtrace-mxgui,
 mcxtrace-mxrun,
 python3-all,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="repack, repacksuffix=+ds5, dversionmangle=s/\+ds\d+//, pgpmode=none" \
https://github.com/McStasMcXtrace/McCode/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
